"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ApiError: () => ApiError,
  ConflictError: () => ConflictError,
  InternalServerError: () => InternalServerError,
  RealtimeRestClient: () => RealtimeRestClient,
  RealtimeSocketClient: () => RealtimeSocketClient,
  ServiceUnavailableError: () => ServiceUnavailableError,
  UnauthorizedError: () => UnauthorizedError,
  ValidationError: () => ValidationError,
  initializeRealtimeMongo: () => initializeRealtimeMongo
});
module.exports = __toCommonJS(src_exports);

// src/rest-client.ts
var import_axios = __toESM(require("axios"));

// src/errors.ts
var _ApiError = class _ApiError extends Error {
  constructor(message, statusCode, details) {
    super(message);
    __publicField(this, "statusCode");
    __publicField(this, "details");
    this.name = "ApiError";
    this.statusCode = statusCode;
    this.details = details;
    Object.setPrototypeOf(this, _ApiError.prototype);
  }
};
__name(_ApiError, "ApiError");
var ApiError = _ApiError;
var _UnauthorizedError = class _UnauthorizedError extends ApiError {
  constructor(message, status, details) {
    super(message, status, details);
    this.name = "UnauthorizedError";
    Object.setPrototypeOf(this, _UnauthorizedError.prototype);
  }
};
__name(_UnauthorizedError, "UnauthorizedError");
var UnauthorizedError = _UnauthorizedError;
var _ValidationError = class _ValidationError extends ApiError {
  constructor(message, details) {
    super(message, 400, details);
    this.name = "ValidationError";
    Object.setPrototypeOf(this, _ValidationError.prototype);
  }
};
__name(_ValidationError, "ValidationError");
var ValidationError = _ValidationError;
var _ConflictError = class _ConflictError extends ApiError {
  constructor(message, details) {
    super(message, 409, details);
    this.name = "ConflictError";
    Object.setPrototypeOf(this, _ConflictError.prototype);
  }
};
__name(_ConflictError, "ConflictError");
var ConflictError = _ConflictError;
var _ServiceUnavailableError = class _ServiceUnavailableError extends ApiError {
  constructor(message, details) {
    super(message, 503, details);
    this.name = "ServiceUnavailableError";
    Object.setPrototypeOf(this, _ServiceUnavailableError.prototype);
  }
};
__name(_ServiceUnavailableError, "ServiceUnavailableError");
var ServiceUnavailableError = _ServiceUnavailableError;
var _InternalServerError = class _InternalServerError extends ApiError {
  constructor(message, details) {
    super(message, 500, details);
    this.name = "InternalServerError";
    Object.setPrototypeOf(this, _InternalServerError.prototype);
  }
};
__name(_InternalServerError, "InternalServerError");
var InternalServerError = _InternalServerError;

// src/rest-client.ts
var devalue = __toESM(require("devalue"));

// src/encoder.ts
var devalueReducers = {};
var devalueRevivers = {
  ObjectId: /* @__PURE__ */ __name((value) => value, "ObjectId")
};

// src/rest-client.ts
var _RealtimeRestClient = class _RealtimeRestClient {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "axiosInstance");
    __publicField(this, "isException");
    __publicField(this, "insertOne");
    __publicField(this, "insertMany");
    __publicField(this, "findOne");
    __publicField(this, "findMany");
    __publicField(this, "findById");
    __publicField(this, "updateOne");
    __publicField(this, "updateMany");
    __publicField(this, "findOneAndUpdate");
    __publicField(this, "findByIdAndUpdate");
    __publicField(this, "replaceOne");
    __publicField(this, "findOneAndReplace");
    __publicField(this, "deleteOne");
    __publicField(this, "deleteMany");
    __publicField(this, "findOneAndDelete");
    __publicField(this, "findByIdAndDelete");
    this.options = options;
    this.isException = (data) => {
      if (typeof data !== "object") return false;
      if (!("message" in data)) return false;
      if (!("error" in data)) return false;
      if (!("statusCode" in data)) return false;
      return true;
    };
    this.insertOne = async (modelName, payload) => {
      const response = await this.axiosInstance.put("database/insertOne", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.insertMany = async (modelName, payload) => {
      const response = await this.axiosInstance.put("database/insertMany", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.findOne = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findOne", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.findMany = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findMany", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.findById = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findById", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.updateOne = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/updateOne", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.updateMany = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/updateMany", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.findOneAndUpdate = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findOneAndUpdate", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.findByIdAndUpdate = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findByIdAndUpdate", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.replaceOne = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/replaceOne", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.findOneAndReplace = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findOneAndReplace", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.deleteOne = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/deleteOne", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.deleteMany = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/deleteMany", payload, {
        params: {
          modelName
        }
      });
      return response.data;
    };
    this.findOneAndDelete = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findOneAndDelete", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.findByIdAndDelete = async (modelName, payload) => {
      const response = await this.axiosInstance.post("database/findByIdAndDelete", payload, {
        params: {
          modelName
        }
      });
      return response.data ?? null;
    };
    this.axiosInstance = import_axios.default.create({
      baseURL: options.baseURL,
      headers: {
        ...this.options.headers,
        Accept: "application/json",
        "Content-Type": "application/json",
        "X-Realtime-SDK": "true"
      },
      withCredentials: options.withCredentials
    });
    this.axiosInstance.interceptors.request.use(async (r) => {
      const restAuth = await this.options.restAuth?.();
      r.headers = r.headers.concat(restAuth);
      return r;
    });
    this.axiosInstance.interceptors.response.use(async (r) => {
      try {
        r.data = devalue.parse(JSON.stringify(r.data), devalueRevivers);
      } catch (e) {
      }
      return r;
    }, (config) => {
      if (!(0, import_axios.isAxiosError)(config) || !config.response) {
        return Promise.reject(config);
      }
      const { status, data } = config.response;
      if (!this.isException(data)) {
        return Promise.reject(config);
      }
      if (status === 404) {
        return Promise.resolve({
          ...config,
          response: {
            ...config.response,
            data: null
          }
        });
      }
      switch (status) {
        case 400:
          return Promise.reject(new ValidationError("Validation Error", data.message));
        case 401:
          return Promise.reject(new UnauthorizedError("Auth Failed", 401, data.message));
        case 403:
          return Promise.reject(new UnauthorizedError("Forbidden", 403, data.message));
        case 409:
          return Promise.reject(new ConflictError("Conflict Error", data.message));
        case 503:
          return Promise.reject(new ServiceUnavailableError("Service Unavailable", data.message));
        case 500:
          return Promise.reject(new InternalServerError("Internal Server Error", data.message));
        default:
          return Promise.reject(new ApiError("An error occurred", status, data.message));
      }
    });
  }
};
__name(_RealtimeRestClient, "RealtimeRestClient");
var RealtimeRestClient = _RealtimeRestClient;

// src/socket-client.ts
var import_socket = require("socket.io-client");
var parser = __toESM(require("@socket.io/devalue-parser"));
var _RealtimeSocketClient = class _RealtimeSocketClient {
  constructor(options) {
    __publicField(this, "options");
    __publicField(this, "_subscribe");
    __publicField(this, "onQuery");
    __publicField(this, "onDocument");
    this.options = options;
    this._subscribe = (modelName, params, onChange, onError, options2) => {
      let shouldDisconnect = false;
      const url = new URL("database", this.options.baseURL);
      const socket = (0, import_socket.io)(url.href, {
        transports: [
          "websocket"
        ],
        extraHeaders: this.options.headers,
        reconnection: true,
        auth: /* @__PURE__ */ __name(async (cb) => {
          const baseObject = {
            modelName,
            ...params
          };
          try {
            const payload = await this.options.wsAuth?.();
            cb({
              ...payload,
              _realtime: baseObject
            });
          } catch (error) {
            console.error("[RealtimeSocketClient] wsAuth Failed:", error);
            cb(baseObject);
          }
        }, "auth"),
        parser: {
          Encoder: parser.Encoder.bind(null, devalueReducers),
          Decoder: parser.Decoder.bind(null, devalueRevivers)
        }
      });
      socket.on("connect", () => {
        if (shouldDisconnect) {
          socket.disconnect();
        }
      });
      socket.on("connect_error", (error) => {
        if (socket.active) return;
        console.error("[RealtimeSocketClient] Connection Error:", error);
        onError?.(error);
      });
      socket.on("exception", (err) => {
        console.error("[RealtimeSocketClient] Server Exception:", err);
        onError?.(err);
      });
      if (options2?.isDocument) {
        socket.on("data", (data) => {
          onChange(data);
        });
        socket.on("remove", () => {
          onChange(null);
        });
        socket.on("update", (data) => {
          onChange(data.data);
        });
        socket.on("add", (data) => {
          onChange(data.data);
        });
      } else {
        const cache = /* @__PURE__ */ new Map();
        socket.on("data", (data) => {
          if (data && Array.isArray(data)) {
            cache.clear();
            data.forEach((item) => cache.set(item._id, item));
            onChange(Array.from(cache.values()));
          }
        });
        socket.on("remove", (data) => {
          cache.delete(data._id);
          onChange(Array.from(cache.values()));
        });
        socket.on("update", (data) => {
          cache.set(data._id, data.data);
          onChange(Array.from(cache.values()));
        });
        socket.on("add", (data) => {
          cache.set(data._id, data.data);
          onChange(Array.from(cache.values()));
        });
      }
      return {
        unsubscribe: /* @__PURE__ */ __name(() => {
          shouldDisconnect = true;
          if (socket.connected) {
            socket.disconnect();
          }
        }, "unsubscribe")
      };
    };
    this.onQuery = (modelName, filter, onChange, onError) => {
      return this._subscribe(modelName, {
        filter
      }, onChange, onError, {
        isDocument: false
      });
    };
    this.onDocument = (modelName, _id, onChange, onError) => {
      return this._subscribe(modelName, {
        _id
      }, onChange, onError, {
        isDocument: true
      });
    };
  }
};
__name(_RealtimeSocketClient, "RealtimeSocketClient");
var RealtimeSocketClient = _RealtimeSocketClient;

// src/index.ts
var initializeRealtimeMongo = /* @__PURE__ */ __name((options) => {
  const databaseRest = new RealtimeRestClient(options);
  const databaseSocket = new RealtimeSocketClient(options);
  return {
    databaseRest,
    databaseSocket
  };
}, "initializeRealtimeMongo");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ApiError,
  ConflictError,
  InternalServerError,
  RealtimeRestClient,
  RealtimeSocketClient,
  ServiceUnavailableError,
  UnauthorizedError,
  ValidationError,
  initializeRealtimeMongo
});
